package info.bukova.isspst.ui.mail;

import info.bukova.isspst.mail.MailMessage;
import info.bukova.isspst.mail.Mailer;
import info.bukova.isspst.reporting.Generator;
import info.bukova.isspst.reporting.GeneratorFactory;
import info.bukova.isspst.reporting.ReportDefinition;

import org.zkoss.bind.annotation.BindingParam;
import org.zkoss.bind.annotation.Command;
import org.zkoss.bind.annotation.ExecutionArgParam;
import org.zkoss.bind.annotation.Init;
import org.zkoss.zk.ui.select.annotation.WireVariable;
import org.zkoss.zul.Window;

public class MailForm {
	
	@WireVariable
	private Mailer mailer;
	@WireVariable
	private ReportDefinition reportDefinition;
	@WireVariable
	private GeneratorFactory genFactory;
	private MailMessage message;
	private String to;
	private String attachement;
	private boolean report;
	
	@Init
	public void init(@ExecutionArgParam("report") Boolean report) {
		message = new MailMessage();
		message.setHtml(true);
		this.report = report;
		if (report) {
			attachement = "report.pdf";
		}
	}
	
	@Command
	public void send(@BindingParam("window") Window window) {
		message.setTo(to);
		if (report) {
			Generator generator = genFactory.createGenerator(reportDefinition);
			message.setAttachementData(generator.generate());
			message.setAttachementName("report.pdf");
			message.setContentType("application/pdf");
		}
		
		mailer.send(message);
		window.detach();
	}

	public MailMessage getMessage() {
		return message;
	}

	public void setMessage(MailMessage message) {
		this.message = message;
	}

	public String getTo() {
		return to;
	}

	public void setTo(String to) {
		this.to = to;
	}

	public String getAttachement() {
		return attachement;
	}

}
